/*
 *  Making libraries is just too painful under Win32/BCC 5.5
 *
 *  The TLIB syntax is just PITA, and the stupid thing insists on
 *  interpreting 'game\load-rst.obj' as 'game\load.obj' plus an
 *  option '-rst.obj'. And we're even talking about file names with
 *  forward slashes here.
 *
 *  This is used as 'mklib path\to\tlib libname.lib obj1.obj obj2.obj...',
 *  it will make an appropriate response file and call tlib.
 *
 *  Public Domain.
 */

#include <stdio.h>
#include <stdlib.h>

#define FILENAME "mklib000.$$$"

int main(int argc, char** argv)
{
    int i, hack = 0;
    char cmdbuf[1000];
    FILE* fp;

    if (argv[1] && strcmp(argv[1], "-hack") == 0)
        hack = 1;

    if (argc < 2) {
        printf("usage: mklib -hack|<path-to-tlib> <libfile> <objfile>...\n");
        return 1;
    }

    if (hack) {
        fp = fopen(argv[2], "w");
        if (!fp) {
            perror(argv[2]);
            return 1;
        }
        fputs("hacklib\n", fp);
        for (i = 3; argv[i]; ++i)
            fprintf(fp, "%s\n", argv[i]);
        fclose(fp);
    } else {
        fp = fopen(FILENAME, "w");
        if (!fp) {
            perror(FILENAME);
            return 1;
        }
        for (i = 3; argv[i]; ++i) {
            fprintf(fp, "+\"%s\" ", argv[i]);
            /* printf("r - %s\n", argv[i]); */
        }
        fclose(fp);
        sprintf(cmdbuf, "%s %s @%s", argv[1], argv[2], FILENAME);
        printf("> %s\n", cmdbuf);
        remove(argv[2]);
        i = system(cmdbuf);
        printf("> exit value is %d\n", i);
        remove(FILENAME);
    }
    return 0;
}
