/**
  *  \file arch\win32-bcc55\shell.cc
  *  \brief Shell folders etc.
  */

// #include <shlobj.h>

#include <windows.h>
#include "arch/platform.h"
#include "cpluslib/string.h"
#include "util/console.h"

#if 0
static LPMALLOC
getShellAllocator()
{
    static LPMALLOC m = 0;
    if (!m)
        SHGetMalloc(&m);
    return m;
}

static string_t
getShellFolder(int csidl)
{
    LPITEMLIST il;
    char buffer[MAX_PATH];
    
    if (!SUCCEEDED(SHGetSpecialFolderLocation(NULL, csidl, &il)))
        return string_t();
    BOOL rv = SHGetPathFromIDList(il, buffer);
    if (LPMALLOC m = getShellAllocator())
        m->lpVtbl->Free(m, il);
    if (rv)
        return string_t(buffer);
    else
        return string_t();
}

string_t
Platform::getUserSettingsDirectory()
{
    string_t rv = getShellFolder(CSIDL_APPDATA);
    if (!rv.length())
        return rv;
    else
        return string_t("C:\\");
}
#else
string_t
Platform::getUserSettingsDirectory()
{
    char c;
    UINT size = GetWindowsDirectory(&c, 0);
    if (size) {
        char* n = new char[size+1];
        GetWindowsDirectory(n, size+1);
        string_t rv(n);
        delete[] n;
        return rv;
    } else {
        return string_t("C:\\");
    }
}
#endif
