/**
  *  \file client/dlg-fcode.h
  *
  *  (c) 2001,2002,2003 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_CLIENT_DLG_FCODE_H
#define PCC_V2_CLIENT_DLG_FCODE_H

#include "ui/ui.h"
#include "ui/widgets.h"
#include "game/fcode.h"
#include "ui/listbox.h"

class WFCodeListbox : public UIListbox {
    const GFCodeList& list;
 public:
    WFCodeListbox(int id, int lines, int width, const GFCodeList& list);
    ~WFCodeListbox();

    void     drawPart(Ptr<GfxCanvas> can, int from, int to);

    void     setFCode(const string_t& fc);
    string_t getFCode() const;
};

class WFCodeWindow : public UIWindow {
    UIGroup          g, g2;
    UIFrameGroup     hg;

    UIInputLine      input;
    WFCodeListbox    fclist;
    UIStaticText     s_text;
    UIButton         b_ok, b_esc, b_help;
    UISpacer         spacer;
    UIScrollbar      scrollbar;
    UIFocusIterator  fiter;

    void edited(int);
    void scrolled(int);
 public:
    WFCodeWindow(const string_t& title, const GFCodeList& list);
    ~WFCodeWindow();

    string_t  getFCode() const { return input.getText(); }
    void      setFCode(const string_t& fc);
};

#endif
