/**
  *  \file client/dlg-list.cc
  *
  *  (c) 2001,2002,2003 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */

#include "client/dlg-list.h"
#include "cpluslib/format.h"
#include "game/global.h"
#include "game/planet.h"
#include "game/player.h"
#include "game/ship.h"
#include "gfx/palette.h"
#include "ui/layout.h"
#include "ui/uiglobal.h"
#include "ui/widgets.h"
#include "ui/window.h"
#include "util/nls.h"
#include "ui/msgbox.h"
#include "cpluslib/holder.h"

// GListShipsData::GListShipsData(GPoint pos, int flags, int except)
//     : pos(pos), flags(flags), except(except)
// {
//     generate();
// }

// GListShipsData::~GListShipsData()
// { }

// void
// GListShipsData::setContent(GPoint pos, int flags, int except)
// {
//     if (pos == this->pos && flags == this->flags && except == this->except)
//         return;

//     this->pos    = pos;
//     this->flags  = flags;
//     this->except = except;
//     generate();
// }

// void
// GListShipsData::generate()
// {
//     GGameTurn& trn = getDisplayedTurn();
//     list.clear();
//     for (int i = 1; i <= NUM_SHIPS; ++i) {
//         if (i == except)
//             continue;

//         GShip& s = trn.getShip(i);
//         if (!s.isExistant())
//             continue;
//         if (s.getPos() != pos)
//             continue;
//         if (!(flags & ls_ListForeignShips) && !trn.isPlaying(s.getOwner()))
//             continue;

//         list.addObject(trn.getShipType(), s);
//     }

//     /* FIXME: sort and add dividers as per sort order */

//     if (flags & ls_WithPlanet) {
//         int pid = trn.getPlanetAt(pos);
//         if (pid)
//             list.addObject(trn.getPlanetType(), trn.getPlanet(pid));
//     }

//     GObjectList::iterator i = list.begin();
//     while (i != list.end() && !i->isGameObject())
//         ++i;
//     if (i == list.end())
//         setCurrent(GObjectId());
//     else
//         setCurrent(*i);

//     sig_list_changed.raise();
// }

// void
// GListShipsData::setCurrent(GObjectId id)
// {
//     if (id == current)
//         return;
//     current = id;
//     sig_changed.raise();
// }

// /*************************** List Ships Dialog ***************************/

// namespace {
//     class WListShipsTile : public WTile {
//         void* key;
//      protected:
//         GListShipsData& the_data;
//      public:
//         WListShipsTile(GfxPoint size, GListShipsData& data);
//         ~WListShipsTile();
//     };

//     class WListShipsNameTile : public WListShipsTile {
//      public:
//         WListShipsNameTile(GListShipsData& data);
//         void drawData(Ptr<GfxCanvas> can);
//     };

//     class WListShipsEquipTile : public WListShipsTile {
//      public:
//         WListShipsEquipTile(GListShipsData& data);
//         void drawData(Ptr<GfxCanvas> can);
//     };

//     class WListShipsWindow : public UIWindow {
//         GListShipsData& the_data;
//         void scroll(int delta);
//      public:
//         WListShipsWindow(GListShipsData& data, const string_t ok,
//                          const string_t ttl);
//         bool handleEvent(const UIEvent& e, bool second_pass);
//     };
// };

// WListShipsTile::WListShipsTile(GfxPoint size, GListShipsData& data)
//     : WTile(size), the_data(data)
// {
//     key = data.sig_changed.add(static_cast<WTile*>(this), &WTile::update);
//     setTheme(tt_LightGray);
// }

// WListShipsTile::~WListShipsTile()
// {
//     the_data.sig_changed.remove(key);
// }

// WListShipsNameTile::WListShipsNameTile(GListShipsData& data)
//     : WListShipsTile(GfxPoint(280, 7*font_heights[FONT_NORMAL]/2), data)
// { }

// void
// WListShipsNameTile::drawData(Ptr<GfxCanvas> can)
// {
//     // FIXME
//     GObjectId id = the_data.getCurrent();

//     setColor(tc_Static);
//     outTextF(can, FONT_NORMAL, 0, 0, extent.w,
//              id.getName());
//     outTextF(can, FONT_NORMAL, 0, font_heights[FONT_NORMAL], extent.w,
//              ::getAdjName(id.getObject().getOwner()));
//     if (GShip* s = dynamic_cast<GShip*>(&id.getObject())) {
//         if (s->getHullId() > 0)
//             outTextF(can, FONT_NORMAL, 0, font_heights[FONT_NORMAL]*5/2, extent.w,
//                      s->getHull().getName());
//         else
//             outTextF(can, FONT_NORMAL, 0, font_heights[FONT_NORMAL]*5/2, extent.w,
//                      _("unknown hull"));
//     } else {
//             outTextF(can, FONT_NORMAL, 0, font_heights[FONT_NORMAL]*5/2, extent.w,
//                      string_t());
//     }
// }

// WListShipsEquipTile::WListShipsEquipTile(GListShipsData& data)
//     : WListShipsTile(GfxPoint(280, 13*font_heights[FONT_NORMAL]/2), data)
// { }

// void
// WListShipsEquipTile::drawData(Ptr<GfxCanvas> can)
// {
//     GObjectId id = the_data.getCurrent();
//     const int y  = font_heights[FONT_NORMAL];
//     const int x  = 120;
//     const int w  = extent.w - x;

//     setColor(tc_Static);
//     if (GShip* s = dynamic_cast<GShip*>(&id.getObject())) {
//         // FIXME: picture
//         if (s->getHullId() > 0) {
//             outTextF(can, FONT_NORMAL, x, 0, w, format(_("Hull mass: %d kt"), s->getHull().getMass()));
//             if (s->haveDat()) {
//                 outTextF(can, FONT_NORMAL, x, y, w, format(_("Cargo: %d/%d kt"),
//                                                            s->getHull().getCargo() - s->getFreeCargo(),
//                                                            s->getHull().getCargo()));
//                 outTextF(can, FONT_NORMAL, x, 2*y, w, format(_("Fuel: %d/%d kt"),
//                                                              s->getOre(CARGO_N),
//                                                              s->getHull().getFuel()));
//             } else {
//                 outTextF(can, FONT_NORMAL, x, y, w, format(_("Max Cargo: %d kt"),
//                                                            s->getHull().getCargo()));
//                 outTextF(can, FONT_NORMAL, x, 2*y, w, format(_("Max Fuel: %d kt"),
//                                                              s->getHull().getFuel()));
//             }
//         } else {
//             drawBackground(can, GfxRect(x, 0, w, extent.h));
//         }
//     } else {
//         drawBackground(can, GfxRect(x, 0, w, extent.h));
//     }
// }

// /* "List Ships" dialog

//    ,-------------------------------.
//    | Name                     | b  |
//    | Type_____________________| u  |
//    | .------------------------. t  |
//    | |           | |  specs   | t  |
//    | |  picture  | |          | o  |
//    | |           | |          | n  |
//    | |           | |          | s  |
//    | `------------------------'    |
//    | more specs               |    |
//    | |________________________|    |
//    |                               |
//    |                ok cancel help |
//    `-------------------------------'

//     VBox
//       HBox
//         VBox
//           NameType
//           Pic/Specs
//           More Specs
//         VBox
//           Buttons: ^ L S R Spacer v
//       HBox
//         Spacer OK Cancel Help */


// WListShipsWindow::WListShipsWindow(GListShipsData& data, const string_t ok,
//                                    const string_t ttl)
//     : UIWindow(ttl, BLUE_WINDOW, COLOR_GRAY),
//       the_data(data)
// {
//     setLayout(new UIVBoxLayout(5));

//     Ptr<UIGroup> main_g = new UIGroup(new UIHBoxLayout(5));
//     Ptr<UIGroup> button_g = new UIGroup(new UIHBoxLayout(5));
//     button_g->add(new UISpacer());
//     button_g->add(new UIButton(1, ok, SDLK_RETURN, UIButton::aStop));
//     button_g->add(new UIButton(0, _("Cancel"), SDLK_ESCAPE, UIButton::aStop));
//     button_g->add(new UIButton(cm_Help, _("Help"), 'h'));

//     Ptr<UIGroup> main_vg = new UIGroup(new UIVBoxLayout(5));
//     main_vg->add(new WListShipsNameTile(data));
//     main_vg->add(new WListShipsEquipTile(data));

//     Ptr<UIGroup> button_vg = new UIGroup(new UIVBoxLayout(5));
//     button_vg->add(new UIButton(cm_Prev, "\036", '-'));
//     button_vg->add(new UISpacer());
//     button_vg->add(new UIButton(0 /* FIXME */, "S", 's'));
//     button_vg->add(new UIButton(0 /* FIXME */, "L", 'l'));
//     button_vg->add(new UIButton(cm_Next, "\037", '+'));

//     main_g->add(main_vg);
//     main_g->add(button_vg);

//     add(main_g);
//     add(button_g);
//     pack();

//     setExtent(GfxRect(10, 10, extent.w, extent.h));
//     setState(st_Modal, true);
// }

// void
// WListShipsWindow::scroll(int delta)
// {
//     int i = the_data.getList().getIndexFor(the_data.getCurrent());
//     int wrap = 0;
//     int max = the_data.getList().getSize();
//     if (max == 0)
//         return;
//     while (1) {
//         i += delta;
//         if (i < 0)
//             i = max-1, ++wrap;
//         if (i >= max)
//             i = 0, ++wrap;
//         if (wrap > 1)
//             return;
//         if (the_data.getList()[i].isGameObject()) {
//             the_data.setCurrent(the_data.getList()[i]);
//             return;
//         }
//     }
// }


// bool
// WListShipsWindow::handleEvent(const UIEvent& e, bool second_pass)
// {
//     if (e.type == ev_Command) {
//         if (e.cmd.code == cm_Next) {
//             scroll(+1);
//             return true;
//         } else if (e.cmd.code == cm_Prev) {
//             scroll(-1);
//             return true;
//         }
//     }
//     return UIWindow::handleEvent(e, second_pass);
// }

// GObjectId
// GListShipsData::doListShipsDialog(string_t title, string_t ok,
//                                   Ptr<WScannerChartWidget> scanner)
// {
//     int n = list.getCount();
//     if (n == 0) {
//         // FIXME: message
//         return GObjectId();
//     }
//     // FIXME: early exit

//     Ptr<WListShipsWindow> win = new WListShipsWindow(*this, ok, title);
//     ui_root->add(win);
//     int rv = ui_root->run();
//     ui_root->close(win);
//     if (rv)
//         return getCurrent();
//     else
//         return GObjectId();
// }

/************************** WObjectSelectionList *************************/

// FIXME: interaction with list.current() etc.

WObjectSelectionList::WObjectSelectionList(int id, int lines, int width, GObjectList& list)
    : UIListbox(id, lines, width, list.getSize()), list(list)
{ }

WObjectSelectionList::~WObjectSelectionList()
{ }

/** Fetch additional information for an object. Derived classes can override
    this to provide additional information for an object. For example,
    in proxy transfer, PCC will show current ship/ship transfers when
    selecting the proxy. */
string_t
WObjectSelectionList::getObjectInfo(GObjectId /*id*/)
{
    return string_t();
}

void
WObjectSelectionList::drawPart(Ptr<GfxCanvas> can, int from, int to)
{
    const int h = getItemHeight();
    GfxParameters parm;

    for (int line = from; line < to; ++line) {
        const int y = extent.y + h * line;
        const int index = getTop() + line;

        if (index >= list.getSize()) {
            can->drawBar(GfxRect(extent.x, y, extent.w, h), standard_colors[COLOR_GRAY],
                         GFX_TRANSPARENT, SOLID_FILL, SDL_ALPHA_OPAQUE);
        } else {
            GObjectId id = list[index];
            int scheme = FOF_TECHIE;
            if (id.isGameObject())
                scheme = isFriend(id.getObject().getOwner());
            if (index == getCurrent()) {
                parm.color   = standard_colors[fof_colors[scheme]];
                parm.bgcolor = hasState(st_Focused) ? standard_colors[COLOR_BLACK] : standard_colors[COLOR_GRAY];
            } else {
                parm.color   = standard_colors[fof_colors_dark[scheme]];
                parm.bgcolor = standard_colors[COLOR_GRAY];
            }
            if (id.getId()) {
                /* FIXME: selection, ... */
                string_t info = getObjectInfo(id);
                if (info.length()) {
                    outTextF(can, parm, fonts[FONT_NORMAL], extent.x, y, extent.w - info_space,
                             " " + id.getName());
                    outTextF(can, parm, fonts[FONT_NORMAL], extent.x + info_space, y, info_space,
                             info);
                } else {
                    outTextF(can, parm, fonts[FONT_NORMAL], extent.x, y, extent.w,
                             " " + id.getName());
                }
            } else {
                /* divider line */
                can->drawBar(GfxRect(extent.x, y, extent.w, h), standard_colors[COLOR_GRAY],
                             GFX_TRANSPARENT, SOLID_FILL, SDL_ALPHA_OPAQUE);
                parm.bgcolor = GFX_TRANSPARENT;
                outTextF(can, parm, fonts[FONT_NORMAL], extent.x + 20, y, extent.w - 40,
                         id.getName());
                parm.color = standard_colors[COLOR_SHIELD+2];
                drawRectangle(can, parm, GfxRect(extent.x, y, extent.w, h));
            }
        }
    }
}

bool
WObjectSelectionList::isAccessible(int index)
{
    return index >= 0 && index < list.getSize() && list[index].getId();
}

/** Select object /id/. \returns true iff ok, false if not. */
bool
WObjectSelectionList::selectObject(GObjectId id)
{
    int index = list.getIndexFor(id);
    if (index >= 0) {
        scrollTo(index, 1);
        return true;
    }
    return false;
}

GObjectId
WObjectSelectionList::doStandardDialog(string_t title, int help_id)
{
    /* can we do something? */
    if (!list.getSize())
        return GObjectId();

    /* okay, go ahead. */
    ObjectHolder holder;

    UIWindow win(title, UIWindow::BLUE_WINDOW, COLOR_GRAY);
    win.setLayout(new UIVBoxLayout(5));
    win.add(*this);

    UIGroup bgroup;
    bgroup.setLayout(new UIHBoxLayout(5));
    bgroup.add(holder.add(new UIButton(1, _("OK"), SDLK_RETURN, UIButton::aStop)));
    bgroup.add(holder.add(new UIButton(0, _("Cancel"), SDLK_ESCAPE, UIButton::aStop)));
    bgroup.add(holder.add(new UISpacer()));
    if (help_id)
        /* FIXME */
        bgroup.add(holder.add(new UIButton(cm_Help, _("Help"), 'h')));
    win.add(bgroup);
    win.setFocus(this);
    win.pack();
    win.setState(st_Modal, true);
    ui_root->centerWidget(win);
    ui_root->add(win);
    int rv = ui_root->run();
    ui_root->close(win);

    if (rv)
        return getCurrentObject();
    else
        return GObjectId();
}

/** Do standard "list ships" dialog.
    \param pt        location to list
    \param flags     flags (ls_XXX)
    \param exclude_ship do not show that ship
    \param title     title line
    \param okname    name of "ok" button
    \param help_id   help page number */
GObjectId
doListShips(GPoint pt, int flags, int exclude_ship,
            string_t title, string_t /*okname*/, int help_id)
{
    /* Initialize list */
    GObjectList l;
    l.addObjectsAt(getDisplayedTurn(), pt, exclude_ship);
    l.postprocessUser(true);
    int n = l.getCount();

    /* List empty? Show message. */
    if (n == 0) {
        string_t msg;
        if (!(flags & ls_IncludeForeignShips)) {
            msg = _("There is no ship of ours at that location.");
        } else {
            GGameTurn& trn = getDisplayedTurn();
            msg = _("We can't locate a ship at that location.");
            int pid = trn.getPlanetAt(pt);
            if (pid && !trn.isPlaying(trn.getPlanet(pid).getOwner()))
                /* this message must start with a space */
                msg += format(_(" The planet %s may be hiding ships from our sensors."),
                              trn.getPlanet(pid).getName());
        }
        messageBox(msg, _("Scanner"));
        return GObjectId();
    }

    /* One object only? Bail out early if allowed. */
    if (n == 1 && (flags & ls_EarlyExit)) {
        GObjectList::size_type n = 0;
        while (!l[n].isGameObject())
            ++n;
        if ((flags & ls_AllowForeignShips) || getDisplayedTurn().isPlaying(getDisplayedTurn().getShip(l[n].getId()).getOwner()))
            return l[n];
    }

    /* Do dialog. */
    WObjectSelectionList the_list(0, 10, 300, l);
    return the_list.doStandardDialog(title, help_id);
}
