/**
  *  \file client/dlg-list.h
  *
  *  (c) 2001,2002,2003 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_CLIENT_LISTSHIP_H
#define PCC_V2_CLIENT_LISTSHIP_H

#include "game/objlist.h"
#include "game/coord.h"
#include "cpluslib/string.h"
#include "client/cscreen.h"
#include "cpluslib/sigslot.h"
#include "ui/listbox.h"

// enum GShipSortOrder {
//     o_Id,
//     o_Owner,
//     o_Type,
//     o_Mass,
//     o_Fleet,
//     o_Tow,
//     o_BattleOrder,
//     o_NewPos,
//     o_NUM
// };

// class GListShipsData {
//     GObjectList list;
//     GPoint      pos;
//     int         flags;
//     int         except;         /* do not list this ship */
//     GObjectId   current;
//     void        generate();
//  public:
//     enum {
//         ls_AllowForeignShips = 1,  /* allow to select foreign ships */
//         ls_ListForeignShips  = 2,  /* list foreign ships */
//         ls_EarlyExit         = 4,  /* do not display window when only one ship */
//         ls_WithPlanet        = 8   /* include planet in listing */
//     };
    
//     GListShipsData(GPoint pos, int flags, int except = 0);
//     ~GListShipsData();

//     void setContent(GPoint pos, int flags, int except = 0);
//     void setCurrent(GObjectId id);
//     GObjectId getCurrent() const { return current; }

//     GObjectId doListShipsDialog(string_t title, string_t ok,
//                                 Ptr<WScannerChartWidget> scanner);

//     const GObjectList& getList() const { return list; }

//     Signal0 sig_changed;
//     Signal0 sig_list_changed;
// };

class WObjectSelectionList : public UIListbox {
    GObjectList&  list;
    int           info_space;
 protected:
    void setInfoSpace(int aspace) { info_space = aspace; }
    virtual string_t getObjectInfo(GObjectId obj);
 public:
    WObjectSelectionList(int id, int lines, int width, GObjectList& list);
    ~WObjectSelectionList();

    /* UIListbox interface */
    void       drawPart(Ptr<GfxCanvas> can, int from, int to);
    bool       isAccessible(int index);

    /* Accessors */
    bool       selectObject(GObjectId id);
    GObjectId  getCurrentObject() const { return list[getCurrent()]; }

    /* Convenience Interface */
    GObjectId doStandardDialog(string_t title, int help_id);
};

GObjectId doListShips(GPoint pt, int flags, int exclude_ship,
                      string_t title, string_t okname, int help_id);


#endif
