/**
  *  \file fileio/multidir.h
  *
  *  (c) 2001,2002,2003 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_FILEIO_MULTIDIR_H
#define PCC_V2_FILEIO_MULTIDIR_H

#include <vector>
#include "fileio/dirs.h"

class MultiDirectory : public Directory {
    typedef std::vector<Ptr<Directory> > dir_vec;
    
    class Enum;
    friend class Enum;
    
    dir_vec dirs;
 public:
    MultiDirectory();
    MultiDirectory(Ptr<Directory> dir);
    void addDirectory(Ptr<Directory> dir);
    Ptr<DirectoryEntry> getEntryByName(string_t name);
    Ptr<Enumeration<Ptr<DirectoryEntry> > > getEntries();
    Ptr<Directory> getParent();
    string_t getName();
};

#endif
