/**
  *  \file game/gamedirs.cc
  *
  *  (c) 2001,2002,2003 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */

#include "game/gamedirs.h"
#include "fileio/multidir.h"

/** Directory with specification files. */
Ptr<Directory> spec_file_dir;

/** Directory with game files. */
Ptr<Directory> game_file_dir;

/** Winplan directory (may be null). */
Ptr<Directory> winplan_dir;

/** Initialize game global values.
    \param gamedir game directory, as specified by the user
    \param rootdir root directory. Either explicitly specified (PHost way),
    the directory the program is in (DOS way), or something in /usr/share
    (Unix way). */
void
initDirectories(string_t gamedir,
                string_t rootdir)
{
    Ptr<Directory> g = Directory::openDir(gamedir);
    Ptr<Directory> r = Directory::openDir(rootdir);
    Ptr<MultiDirectory> m = new MultiDirectory();

    game_file_dir = g;

    m->addDirectory(g);
    m->addDirectory(r);
    spec_file_dir = m;
}
