/**
  *  \file game/gen.h
  *
  *  (c) 2001,2002,2003 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_GAME_GEN_H
#define PCC_V2_GAME_GEN_H

#include "game/struct.h"
#include "cpluslib/string.h"
#include "fileio/io.h"

//! GENx.DAT parser.
class GGen {
    TGen gen;
    char sig2[10];
    unsigned getPassword(char*) const;
    void genSig();
 public:
    static const char NOPASSWORD[];

    GGen() { }
    GGen(const TGen& agen);
    GGen(const TResultGen& agen);

    /* Accessors */
    int getTurnNr() const { return gen.turn; }
    int getPlayerId() const { return gen.player_id; }
    string_t getTimestamp() const { return getBasicString (gen.timestamp); }

    /* Password access */
    bool isPassword(string_t apass) const;
    bool hasPassword() const;
    void setPassword(string_t apass);
    void setPasswordFromTurn(const char* data);

    /* Signature 1 and 2 as per filefmt.txt */
    const char* getSig1() const { return &gen.password[10]; }
    const char* getSig2() const { return sig2; }
};

#endif
