/**
  *  \file game/obj.cc
  *
  *  (c) 2001,2002,2003 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */

#include "game/obj.h"

/** \class GObject
    \brief Game Object

    Base class for a "physical" game object. */
GObject::~GObject()
{ }

/** \class GMapObject
    \brief Game Object on Map

    Base class for a "physical" game object on the map. */
GMapObject::~GMapObject()
{ }

/** \class GCircularObject
    \brief Game Object on Map, with Extent

    Base class for a "physical" game object on the map, which has
    a nonzero radius (e.g. ion storm). */
GCircularObject::~GCircularObject()
{ }
