/**
  *  \file game/obj.h
  *
  *  (c) 2001,2002,2003 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_GAME_OBJ_H
#define PCC_V2_GAME_OBJ_H

#include "game/coord.h"
#include "cpluslib/string.h"

class GObject {
    GObject(const GObject&);
    GObject& operator=(const GObject&);
 public:
    GObject() { }
    virtual ~GObject();

    virtual string_t getName()     const = 0;
    virtual string_t getFullName() const = 0;
    virtual int      getId()       const = 0;
    virtual int      getOwner()    const = 0;
    virtual bool     isExistant()  const = 0;
};

class GMapObject : public GObject {
 public:
    virtual ~GMapObject();
    virtual GPoint getPos() const = 0;
};

class GCircularObject : public GMapObject {
 public:
    virtual ~GCircularObject();
    virtual int getRadius() const = 0;
};

enum {
    CARGO_N,
    CARGO_T,
    CARGO_D,
    CARGO_M
};

#endif
