/**
  *  \file game/player.h
  *
  *  (c) 2001,2002,2003 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_PLAYER_H
#define PCC_V2_PLAYER_H

#include <string>
#include "cpluslib/string.h"
#include "fileio/streams.h"

enum {
    FOF_ME,
    FOF_FRIEND,
    FOF_ENEMY,
    FOF_UNOWNED,
    FOF_TECHIE    /* used in selection lists for technical things like dividers etc. */
};

class GRaceNameList {
    string_t short_names[13], long_names[13], adjectives[13];
 public:
    GRaceNameList(Stream* p = 0);
    ~GRaceNameList();
    void load(Stream*);
    const string_t& getShortName(int player);
    const string_t& getFullName(int player);
    const string_t& getAdjName(int player);

    string_t expandNames(string_t text);
};

extern int fof_colors[], fof_colors_dark[];
extern GRaceNameList racename_data;
extern char player_chars[];

inline string_t getShortName(int player) { return racename_data.getShortName(player); }
inline string_t getFullName(int player) { return racename_data.getFullName(player); }
inline string_t getAdjName(int player) { return racename_data.getAdjName(player); }

/* These player ids are used for display, not for rules */
int getPlayerId();
int getRealPlayerId();
int isFriend(int player);
void setPlayerIds(int eff, int real);

int getPlayerIdFromChar(char c);
inline char getPlayerChar(int player) { return player_chars[player]; }

bool allowRegistered(int player);

void initRaceNames();

inline string_t expandRaceNames(const string_t& text) { return racename_data.expandNames(text); }

#endif
