/**
  *  \file game/reg.h
  *  \brief Functions for dealing with Registrations
  *
  *  (c) 2001,2002,2003 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_GAME_REG_H
#define PCC_V2_GAME_REG_H

#include "fileio/streams.h"
#include "cpluslib/types.h"

//! Registration info.
class GRegInfo {
    uint32 fizz[51];
    char wpstrings[2][50];
    static uint32 unreg_fizz[];
    string_t decode(int n) const;
    void initFromFizz(const uint32* data);
 public:
    GRegInfo();
    
    void initUnregistered();
    void initUnowned();

    string_t getRegStr1() const;
    string_t getRegStr2() const;
    string_t getRegStr3() const;
    string_t getRegStr4() const;
    bool     isRegistered() const;

    const uint32* getKey() const { return fizz; }

    void setRegStr3(const string_t& str);
    void setRegStr4(const string_t& str);

    void parseFizz(Stream* s);
    void parseKey(Stream* s);
};

extern GRegInfo reginfo;

inline GRegInfo&
getRegInfo() {
    return reginfo;
}

void initRegInfo();

#endif
