/**
  *  \file game/save.h
  *
  *  (c) 2001,2002,2003 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_GAME_SAVE_H
#define PCC_V2_GAME_SAVE_H

#include "cpluslib/smartptr.h"
#include "cpluslib/types.h"
#include "fileio/dirs.h"
#include "fileio/streams.h"

class GGameTurn;

enum {
    /* Flags for saving */
    save_ChecksumCount = 1
};

void saveShips(GGameTurn& trn, Ptr<Stream> str, int src, uint32* checksum, int flags);
void savePlanets(GGameTurn& trn, Ptr<Stream> str, int src, uint32* checksum, int flags);
void saveBases(GGameTurn& trn, Ptr<Stream> str, int src, uint32* checksum, int flags);

void saveDirectory(GGameTurn& trn, Ptr<Directory> dir, int player_mask);
void saveTurns(GGameTurn& trn, Ptr<Directory> dir, int player_mask);

#endif
