/**
  *  \file game/transact.h
  *
  *  (c) 2001,2002,2003 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_GAME_TRANSACT_H
#define PCC_V2_GAME_TRANSACT_H

///! Transaction.
class GTransaction {
    enum Result { Nothing, Committed, Cancelled };
    Result result;
    Result must_result;
    void finish(Result);
 protected:
    GTransaction()
        : result(Nothing), must_result(Nothing) { }
 public:
    virtual ~GTransaction();
    virtual void commit() = 0;
    virtual void cancel() = 0;

    bool isFinished() const { return result != Nothing; }

    void mustCommit();
    void mustCancel();
};

inline void GTransaction::commit() { finish(Committed); }
inline void GTransaction::cancel() { finish(Cancelled); }

#endif
