/**
  *  \file game/utilread.h
  *  \brief UTILx.DAT Reading
  *
  *  (c) 2001,2002,2003 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_GAME_UTILREAD_H
#define PCC_V2_GAME_UTILREAD_H

#include "fileio/streams.h"

//! Logic for reading UTILx.DAT
class GUtilReader {
    Ptr<Stream> s;
 public:
    GUtilReader(Ptr<Stream> as);
    virtual ~GUtilReader();
    void read();
    bool check(string_t* ts);
    virtual bool process(int rec_id, std::size_t size, const char* data);
};

#endif
