/**
  *  \file gfx/init.h
  *  \brief Common Graphics Initialisation code
  *
  *  (c) 2001,2002,2003 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_GFX_INIT_H
#define PCC_V2_GFX_INIT_H

#include <SDL.h>

/// Manifest constants.
enum {
    GFX_MIN_WIDTH  = 640,
    GFX_MIN_HEIGHT = 480
};

class StandardCommandLineParser;

SDL_Surface* initGraphics(const char* icon_file, const char* window_title);
void initGraphicsOptions(StandardCommandLineParser& par);

#endif
