/**
  *  \file palette.cc
  *
  *  (c) 2001,2002,2003 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */

#include <cstddef>
#include "gfx/palette.h"

/** Standard Palette. This defines the standard colors used for
    the program. */
SDL_Color standard_palette[NUM_STANDARD_COLORS] = {
    {   0,   0,   0, 0 },    // 0
    {  97,  97,  97, 0 },    // 1
    { 194, 194, 194, 0 },    // 2
    {  97, 242,  97, 0 },    // 3
    { 255,   0,   0, 0 },    // 4
    {  64, 129,  64, 0 },    // 5
    {  97,  97, 194, 0 },    // 6
    { 129, 129, 194, 0 },    // 7
    {  97,  97, 129, 0 },    // 8
    { 255, 255,   0, 0 },    // 9
    { 121,  97, 121, 0 },    // 10       30 24 30
    { 129, 129, 129, 0 },    // 11       32 32 32
    { 178, 178, 137, 0 },    // 12       44 44 34
    {   0,   0,   0, 0 },    // 13
    {   0,   0,   0, 0 },    // 14
    { 255, 255, 255, 0 },    // 15
    {  12,  12,  12, 0 },    // 16
    {  28,  28,  28, 0 },    // 17
    {  44,  44,  44, 0 },    // 18
    {  60,  60,  60, 0 },    // 19
    {  76,  76,  76, 0 },    // 20
    {  93,  93,  93, 0 },    // 21
    { 109, 109, 109, 0 },    // 22
    { 125, 125, 125, 0 },    // 23
    { 141, 141, 141, 0 },    // 24
    { 157, 157, 157, 0 },    // 25
    { 174, 174, 174, 0 },    // 26
    { 190, 190, 190, 0 },    // 27
    { 206, 206, 206, 0 },    // 28
    { 222, 222, 222, 0 },    // 29
    { 238, 238, 238, 0 },    // 30
    { 255, 255, 255, 0 },    // 31
    {   0,   0,   0, 0 },    // 32
    {  24,   8,   0, 0 },    // 33
    {  48,  16,   0, 0 },    // 34
    {  72,  24,   0, 0 },    // 35
    {  97,  32,   0, 0 },    // 36
    { 121,  40,   0, 0 },    // 37
    { 145,  48,   0, 0 },    // 38
    { 170,  56,   0, 0 },    // 39
    { 194,  64,   0, 0 },    // 40
    { 218,  72,   0, 0 },    // 41
    { 242,  80,   0, 0 },    // 42
    { 255,  85,   0, 0 },    // 43
    { 255,  97,   0, 0 },    // 44
    { 255, 109,   0, 0 },    // 45
    { 255, 121,   0, 0 },    // 46
    { 255, 133,   0, 0 },    // 47
    { 255, 145,   0, 0 },    // 48
    { 255, 157,   0, 0 },    // 49
    { 255, 170,   0, 0 },    // 50
    { 255, 182,   0, 0 },    // 51
    { 255, 194,   0, 0 },    // 52
    { 255, 206,   0, 0 },    // 53
    { 255, 218,   0, 0 },    // 54
    { 255, 230,   0, 0 },    // 55
    { 255, 242,   0, 0 },    // 56
    { 255, 255,   0, 0 },    // 57
    { 255, 255,  32, 0 },    // 58
    { 255, 255,  72, 0 },    // 59
    { 255, 255, 113, 0 },    // 60
    { 255, 255, 153, 0 },    // 61
    { 255, 255, 194, 0 },    // 62
    { 255, 255, 234, 0 },    // 63
    {   0,   0,   0, 0 },    // 64
    {   0,   0,  28, 0 },    // 65
    {   0,   0,  56, 0 },    // 66
    {   0,   0,  85, 0 },    // 67
    {  32,  32, 121, 0 },    // 68
    {  52,  52, 133, 0 },    // 69
    {  72,  72, 145, 0 },    // 70
    {  93,  93, 157, 0 },    // 71
    { 113, 113, 170, 0 },    // 72
    { 133, 133, 182, 0 },    // 73
    { 153, 153, 194, 0 },    // 74
    { 174, 174, 206, 0 },    // 75
    { 194, 194, 218, 0 },    // 76
    { 214, 214, 230, 0 },    // 77
    { 234, 234, 242, 0 },    // 78
    { 255, 255, 255, 0 },    // 79
    { 255,  12,   0, 0 },    // 80
    { 238,  28,   0, 0 },    // 81
    { 222,  44,   0, 0 },    // 82
    { 206,  60,   0, 0 },    // 83
    { 190,  76,   0, 0 },    // 84
    { 174,  93,   0, 0 },    // 85
    { 157, 109,   0, 0 },    // 86
    { 141, 125,   0, 0 },    // 87
    { 125, 141,   0, 0 },    // 88
    { 109, 157,   0, 0 },    // 89
    {  93, 174,   0, 0 },    // 90
    {  76, 190,   0, 0 },    // 91
    {  60, 206,   0, 0 },    // 92
    {  44, 222,   0, 0 },    // 93
    {  28, 238,   0, 0 },    // 94
    {  12, 255,   0, 0 },    // 95
    { 149, 149, 202, 0 },    // 96
    {   0,   0, 170, 0 },    // 97
    {  85,  85, 255, 0 },    // 98
    {   0, 170,   0, 0 },    // 99
    {  85, 255,  85, 0 },    // 100
    {   0, 170, 170, 0 },    // 101
    {  85, 255, 255, 0 },    // 102
    { 170,   0,   0, 0 },    // 103
    { 255,  85,  85, 0 },    // 104
    { 170,   0, 170, 0 },    // 105
    { 255,  85, 255, 0 },    // 106
    { 170, 170,   0, 0 },    // 107
    { 255, 255,  85, 0 },    // 108
    { 125,  97,   0, 0 },    // 109
    { 194,  97,   0, 0 },    // 110
    { 194,  97, 121, 0 },    // 111
    { 230, 137, 137, 0 },    // 112
    { 255, 121,   0, 0 },    // 113
    { 255, 194,   0, 0 },    // 114
    { 129,  64,  97, 0 },    // 115
    { 194,  97, 255, 0 },    // 116
    {  68, 141,  68, 0 },    // 117
    {  72, 157,  72, 0 },    // 118
    {  76, 170,  76, 0 },    // 119
    {  80, 186,  80, 0 },    // 120
    {  85, 202,  85, 0 },    // 121
    {  89, 214,  89, 0 },    // 122
    {  93,   0,  93, 0 },    // 123
    {  72,  72,   0, 0 },    // 124
    {  48,  48,   0, 0 },    // 125
    {  28,  28,   0, 0 },    // 126
    { 109,  72,  72, 0 },    // 127
    {   0,  12,   0, 0 },    // 128
    {   0,  28,   0, 0 },    // 129
    {   0,  44,   0, 0 },    // 130
    {   0,  60,   0, 0 },    // 131
    {   0,  76,   0, 0 },    // 132
    {   0,  93,   0, 0 },    // 133
    {   0, 109,   0, 0 },    // 134
    {   0, 125,   0, 0 },    // 135
    {   0, 141,   0, 0 },    // 136
    {   0, 157,   0, 0 },    // 137
    {   0, 174,   0, 0 },    // 138
    {   0, 190,   0, 0 },    // 139
    {   0, 206,   0, 0 },    // 140
    {   0, 222,   0, 0 },    // 141
    {   0, 238,   0, 0 },    // 142
    {   0, 255,   0, 0 },    // 143
    {  12,  12,   0, 0 },    // 144
    {  28,  28,   0, 0 },    // 145
    {  44,  44,   0, 0 },    // 146
    {  60,  60,   0, 0 },    // 147
    {  76,  76,   0, 0 },    // 148
    {  93,  93,   0, 0 },    // 149
    { 109, 109,   0, 0 },    // 150
    { 125, 125,   0, 0 },    // 151
    {   0,   0,   0, 0 },    // 152
    {   0,   0,   0, 0 },    // 153
    {   0,   0,   0, 0 },    // 154
    {   0,   0,   0, 0 },    // 155
    {   0,   0,   0, 0 },    // 156
    {   0,   0,   0, 0 },    // 157
    {   0,   0,   0, 0 },    // 158
    {   0,   0,   0, 0 },    // 159
    {   0,   0,   0, 0 },    // 160
    {   0,   0,   0, 0 },    // 161
    {   0,   0,   0, 0 },    // 162
    {   0,   0,   0, 0 },    // 163
    {   0,   0,   0, 0 },    // 164
    {   0,   0,   0, 0 },    // 165
    {   0,   0,   0, 0 },    // 166
    {   0,   0,   0, 0 },    // 167
    {   0,   0,   0, 0 },    // 168
    {   0,   0,   0, 0 },    // 169
    {   0,   0,   0, 0 },    // 170
    {   0,   0,   0, 0 },    // 171
    {   0,   0,   0, 0 },    // 172
    {   0,   0,   0, 0 },    // 173
    {   0,   0,   0, 0 },    // 174
    {   0,   0,   0, 0 },    // 175
    {   0,   0,   0, 0 },    // 176
    {   0,   0,   0, 0 },    // 177
    {   0,   0,   0, 0 },    // 178
    {   0,   0,   0, 0 },    // 179
    {   0,   0,   0, 0 },    // 180
    {   0,   0,   0, 0 },    // 181
    {   0,   0,   0, 0 },    // 182
    {   0,   0,   0, 0 },    // 183
    {   0,   0,   0, 0 },    // 184
    {   0,   0,   0, 0 },    // 185
    {   0,   0,   0, 0 },    // 186
    {   0,   0,   0, 0 },    // 187
    {   0,   0,   0, 0 },    // 188
    {   0,   0,   0, 0 },    // 189
    {   0,   0,   0, 0 },    // 190
    {   0,   0,   0, 0 },    // 191
    {   0,   0,   0, 0 },    // 192
    {   0,   0,   0, 0 },    // 193
    {   0,   0,   0, 0 },    // 194
    {   0,   0,   0, 0 },    // 195
    {   0,   0,   0, 0 },    // 196
    {   0,   0,   0, 0 },    // 197
    {   0,   0,   0, 0 },    // 198
    {   0,   0,   0, 0 },    // 199
    {   0,   0,   0, 0 },    // 200
    {   0,   0,   0, 0 },    // 201
    {   0,   0,   0, 0 },    // 202
    {   0,   0,   0, 0 },    // 203
    {   0,   0,   0, 0 },    // 204
    {   0,   0,   0, 0 },    // 205
    {   0,   0,   0, 0 },    // 206
    {   0,   0,   0, 0 },    // 207
    {   0,   0,   0, 0 },    // 208
    {   0,   0,   0, 0 },    // 209
    {   0,   0,   0, 0 },    // 210
    {   0,   0,   0, 0 },    // 211
    {   0,   0,   0, 0 },    // 212
    {   0,   0,   0, 0 },    // 213
    {   0,   0,   0, 0 },    // 214
    {   0,   0,   0, 0 },    // 215
    {   0,   0,   0, 0 },    // 216
    {   0,   0,   0, 0 },    // 217
    {   0,   0,   0, 0 },    // 218
    {   0,   0,   0, 0 },    // 219
    {   0,   0,   0, 0 },    // 220
    {   0,   0,   0, 0 },    // 221
    {   0,   0,   0, 0 },    // 222
    {   0,   0,   0, 0 },    // 223
};

/** Standard Colors. For each palette entry, the corresponding color slot.
    On 8-bit screens, this is a 1:1 mapping; on truecolor screens, these
    values contain the ready-made palette entries. */
uint32 standard_colors[NUM_STANDARD_COLORS];

/** Initialize palette. This sets up the standard_colors array. */
void
initPalette(SDL_Surface* sfc)
{
    if (sfc->format->BytesPerPixel == 1) {
        SDL_SetPalette(sfc, SDL_LOGPAL | SDL_PHYSPAL,
                       standard_palette, 0, NUM_STANDARD_COLORS);
        for (std::size_t i = 0; i < NUM_STANDARD_COLORS; ++i)
            standard_colors[i] = i;
    } else {
        for (std::size_t i = 0; i < NUM_STANDARD_COLORS; ++i)
            standard_colors[i] = SDL_MapRGB(sfc->format,
                                            standard_palette[i].r,
                                            standard_palette[i].g,
                                            standard_palette[i].b);
    }
}
