/**
  *  \file int/csource.cc
  *
  *  (c) 2001,2002,2003 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */

#include "int/csource.h"

IntStreamCommandSource::IntStreamCommandSource(Ptr<Stream> s)
    : IntCommandSource(true), str(s), ps(s)
{ }

IntStreamCommandSource::~IntStreamCommandSource()
{ }

bool
IntStreamCommandSource::getLine(string_t& line)
{
    if (::getline(str, line)) {
        ++line_nr;
        return true;
    } else {
        return false;
    }
}

string_t
IntStreamCommandSource::getName()
{
    return "File " + ps->getName();
}
