/**
  *  \file int/csource.h
  *
  *  (c) 2001,2002,2003 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_INT_CSOURCE_H
#define PCC_V2_INT_CSOURCE_H

#include "cpluslib/misc.h"
#include "fileio/streams.h"
#include "fileio/iostr.h"
#include "cpluslib/string.h"

class IntCommandSource : public Object {
    bool multiline;
 protected:
    int line_nr;
 public:
    IntCommandSource(bool multiline)
        : multiline(multiline), line_nr(0) { }
    virtual bool getLine(string_t&) = 0;
    virtual string_t getName() = 0;

    bool isMultiline() const { return multiline; }
    int  getLineNr() const { return line_nr; }
};

class IntStreamCommandSource : public IntCommandSource {
    StandardStream str;
    Ptr<Stream> ps;
 public:
    IntStreamCommandSource(Ptr<Stream> s);
    ~IntStreamCommandSource();
    bool getLine(string_t&);
    string_t getName();
};

#endif
