/**
  *  \file int/fun-tbl.cc
  *  \brief Function Tables
  *
  *  (c) 2001,2002,2003 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */

#include "int/data.h"
#include "int/fun-tbl.h"

/********************************* Unary *********************************/

IntObject FNot(IntObject);
IntObject FBool(IntObject);
IntObject FNegate(IntObject);
IntObject FAbs(IntObject);
IntObject FInt(IntObject);
IntObject FRound(IntObject);
IntObject FSqrt(IntObject);
IntObject FZap(IntObject);
IntObject FChr(IntObject);
IntObject FAsc(IntObject);
IntObject FCos(IntObject);
IntObject FSin(IntObject);
IntObject FTan(IntObject);

IntFunction1Ptr unary_table [] = {
    FNot,
    FBool,
    FNegate,
    FAbs,
    FInt,
    FRound,
    FSqrt,
    FZap,
    FChr,
    FAsc,
    FCos,
    FSin,
    FTan,
    0
};

/********************************* Binary ********************************/

IntObject FSequence(IntObject, IntObject);
IntObject FLT(IntObject, IntObject);
IntObject FGT(IntObject, IntObject);
IntObject FLE(IntObject, IntObject);
IntObject FGE(IntObject, IntObject);
IntObject FEQ(IntObject, IntObject);
IntObject FNE(IntObject, IntObject);
IntObject FPlus(IntObject, IntObject);
IntObject FMinus(IntObject, IntObject);
IntObject FMul(IntObject, IntObject);
IntObject FDiv(IntObject, IntObject);
IntObject FMod(IntObject, IntObject);
IntObject FRealDiv(IntObject, IntObject);
IntObject FConcat(IntObject, IntObject);
IntObject FHash(IntObject, IntObject);
IntObject FPow(IntObject, IntObject);

IntFunction2Ptr binary_table [] = {
    FSequence,
    FLT,
    FGT,
    FLE,
    FGE,
    FEQ,
    FNE,
    FPlus,
    FMinus,
    FMul,
    FDiv,
    FMod,
    FRealDiv,
    FConcat,
    FHash,
    FPow,
    0
};

/******************************** Ternary ********************************/

IntFunction3Ptr ternary_table [] = {
    0
};
