/**
  *  \file game/pred.h
  *  \brief Predicates for Matching Objects
  */
#ifndef PCC_V2_GAME_PRED_H
#define PCC_V2_GAME_PRED_H

#include "game/obj.h"

class GCirObjPredicate {
 public:
    virtual ~GCirObjPredicate();
    virtual bool accept(GCircularObject* obj) const = 0;
};

class GMapObjPredicate : public GCirObjPredicate {
 public:
    ~GMapObjPredicate();
    bool accept(GCircularObject* obj) const;
    virtual bool accept(GMapObject* obj) const = 0;
};

class GObjPredicate : public GMapObjPredicate {
 public:
    ~GObjPredicate();
    bool accept(GMapObject* obj) const;
    virtual bool accept(GObject* obj) const = 0;
};

/* Standard Predicates */
class GMapObjIsAt : public GMapObjPredicate {
    GPoint pt;
 public:
    GMapObjIsAt(int ax, int ay)
        : pt(ax, ay) { }
    GMapObjIsAt(GPoint apt)
        : pt(apt) { }
    bool accept(GMapObject* obj) const;
};

class GObjAny : public GObjPredicate {
 public:
    bool accept(GObject* obj) const;
};

#endif
