/**
  *  \file resmgr/res-cc1.h
  *
  *  (c) 2001,2002,2003 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_RESMGR_RES_CC1_H
#define PCC_V2_RESMGR_RES_CC1_H

#include "resmgr/resmgr.h"
#include "fileio/io.h"

class ResourceStream : public SubStreamBase {
    struct Entry {
        uint16    id;
        uint32    pos;
        uint32    len;
        
        static const TStructureParser parser[];
        enum { size = 10, count = 3 };
    };
    struct Header {
        uint16    magic;
        uint32    dirpos;
        uint16    nentries;
        static const TStructureParser parser[];
        enum { size = 8, count = 3 };
    };
    Header header;
    Buffer<Entry> rd;
 public:
    ResourceStream(Ptr<Stream> aworker);
    ~ResourceStream();
    bool seekId(uint16 id);
};

class ResProviderResFile : public ResProvider {
    Ptr<ResourceStream> res;
 public:
    ResProviderResFile(Ptr<Stream> s);
    ResProviderResFile(string_t name);
    ~ResProviderResFile();
    Ptr<Stream> getEntry(ResID id, ResClass rc);
};

#endif
