#!/usr/bin/perl
#
#  Blurb-O-Matic.
#
#  Copyright notice must be in a file called `.blurb'; starting with a
#  line that contains a `(c)'.
#
#  Files to modify must be on command line
#

open BLURB, "< .blurb" or die "can't open .blurb";
@blurb = <BLURB>;
close BLURB;

ARG:
foreach (@ARGV) {
    my $fn = $_;
    unless (/\.cc?$/ || /\.h$/) {
	print STDERR "$0: I'll not touch `$_'.\n";
	next;
    }
    if (! -f $_ || -l $_) {
	print STDERR "$0: `$_' is not a regular file.\n";
	next;
    }
    open FILE, "< $_" or die "can't open $_: $!";
    open OUT, "> temp" or die "can't create temp file: $!";

    my $printing = 1;
    my $header = 1;
    my $seenfile = 0;
    while(<FILE>) {
	if ($header) {
	    if(m,\*/,) {
                if (!$seenfile) {
                    print STDERR "$0: `$fn' does not contain \\file, skipping it.\n";
                    close OUT;
                    unlink "temp";
                    next ARG;
                }
		print OUT "  *\n" if $printing;
		$header = 0;
		$printing = 1;
		print OUT @blurb;
		$_ = "  */\n";
	    }
            if (/\\file/) {
                $seenfile = 1;
            }
	    if (m,\(c\),) {
		$printing = 0;
	    }
	}
	print OUT if $printing;
    }
    close FILE;
    close OUT;
    if (system "cmp", "-s", $fn, "temp") {
        rename "temp", "$fn" or warn "can't rename to $fn: $!";
    } else {
        unlink "temp";
    }
}
