#!/usr/bin/perl -w
#
#  "FIXME" report generator.
#
#  find . -name "*.cc" -o -name "*.h" | xargs perl fixme.pl
#

use strict;
use vars qw($file);

foreach $file (@ARGV) {
    open FILE, "< $file" or do {
	print STDERR "$file: $!\n";
	next;
    };
    my $context = "<top>";
    my $line = 0;
    while (<FILE>) {
	++$line;
	if (/^(?:(?:class|static|extern|struct|union)\s+)*(([A-Za-z0-9_]|::|operator ?.[^\(])+)/) {
	    $context = "$1";
	}
	if (/FIXME[:?]\s*/) {
	    my @text = ($');
	    my $line1 = $line;
	    if ($` =~ m,/\*,) {
		my $x;
		while ($text[-1] !~ m,\*/, && ($x = <FILE>)) {
		    $x =~ s/^\s+//;
		    push @text, $x;
		    ++$line;
		}
	    } else {
		my $x;
		while (($x = <FILE>) =~ m,^\s*//+\s*(.*),) {
		    push @text, $1;
		    ++$line;
		}
	    }
	    $text[-1] =~ s,\s*\*/.*,,;
	    chomp @text;
	    print "$file:$line1: in `$context':\n";
	    foreach (@text) {
		print "$file:$line1:   $_\n"
                    unless $_ =~ /^\s*$/;
	    }
	}
    }
}
