#!/usr/bin/perl -w
#
#  Convert PCC 1 .gfx file to PCC 2 palette.
#

foreach (@ARGV) {
    open FILE, "+< $_" or do {
        print STDERR "can't open $_: $!\n";
        next;
    };
    binmode FILE;
    read FILE, $mawihe, 6;
    my ($ma, $wi, $he) = unpack "vvv", $mawihe;
    if ($ma != 0x800) {
        print STDERR "invalid magic number in $_\n";
        close FILE;
        next;
    }
    print "$_: $wi x $he\n";
    read FILE, $data, $wi * $he;
    my $bytes = join "", map { 
        ord($_) == 0 ? ' '
            : (ord($_) >= 16 && ord($_) < 255 ? chr(ord($_) - 32) : $_) } split //, $data;
    seek FILE, 6, 0;
    print FILE $bytes;
    close FILE;
}
