/**
  *  \file sound/sound-cf.cc
  *
  *  (c) 2001,2002,2003 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */

#include "sound/sound.h"
#include "util/confpars.h"

void
loadSoundConfig()
{
    SfxConfig config = getSoundConfig();

    config_file.getValue("sound.frequency", config.frequency);
    config_file.getValue("sound.stereo", config.stereo);
    config_file.getValue("sound.16bits", config.sixteen_bits);
    config_file.getValue("sound.enabled", config.enabled);
    config_file.getValue("sound.headphone", config.headphone);
    config_file.getValue("sound.reverse", config.reverse_stereo);

    configureSound(config);
}

void
saveSoundConfig()
{
    const SfxConfig& config = getSoundConfig();
    
    config_file.setValue("sound.frequency", config.frequency);
    config_file.setValue("sound.stereo", config.stereo);
    config_file.setValue("sound.16bits", config.sixteen_bits);
    config_file.setValue("sound.enabled", config.enabled);
    config_file.setValue("sound.headphone", config.headphone);
    config_file.setValue("sound.reverse", config.reverse_stereo);
}
