/*
 *  TEST: atom(), atomStr(), atomNC(), isAtom()
 *
 *  This provides an interactive interface to the atom primitives.
 */

#include <iostream>
#include "util/atom.h"

int main()
{
    std::cout << "+string    -> add atom (atom)\n"
                 "-number    -> get atom (atomStr)\n"
                 "?number    -> is there an atom with that number? (isAtom)\n"
                 "qstring    -> is there an atom with that text (atomNC)\n";
    while (1) {
        char cmd;
        atom_t at;
        string_t str;
        if (!std::cin.get(cmd))
            break;
        switch (cmd) {
         case '+':
            getline(std::cin, str);
            std::cout << "atom(\"" << str << "\") = " << atom(str) << "\n";
            break;
         case '-':
            std::cin >> at;
            std::cout << "atomStr(" << at << ") = \"" << atomStr(at) << "\"\n";
            break;
         case '?':
            std::cin >> at;
            std::cout << "isAtom(" << at << ") = " << (isAtom(at) ? "true" : "false") << "\n";
            break;
         case 'q':
            getline(std::cin, str);
            std::cout << "atomNC(\"" << str << "\") = " << atomNC(str) << "\n";
            break;
        }
    }
}
