/*
 *  TEST: Recoder
 *
 *  This takes command line parameters: two character set names and
 *  any number of text strings. The text strings are recoded from
 *  character set 1 to character set 2 and output to stdout.
 */
#include <iostream>
#include "util/recode.h"
#include "cpluslib/string.h"

int main(int argc, char** argv)
{
    if (argc < 3) {
        std::cout << "usage: $0 from-cs to-cs text....\n";
        return 1;
    }
    Recoder r(Recoder::getCharsetByName(argv[1]),
              Recoder::getCharsetByName(argv[2]));
    for (int i = 3; argv[i]; ++i) {
        std::cout << argv[i] << " -> " << r.recodeString(string_t(argv[i])) << "\n";
    }
}
