/*
 *  TEST: NLS
 *
 *  This takes a file name (relative to resource/) and a number of
 *  strings on the command line, and outputs the translations of the
 *  strings to stdout.
 */
#include <iostream>
#include "util/nls.h"
#include "util/except.h"

int main(int argc, char** argv)
{
    char* file = *++argv;
    if (!file) {
        std::cerr << "usage: " << *--argv << " filename [text....]\n";
        return 1;
    }
    try {
        loadLanguageDatabase(file);
    }
    catch(std::exception& e) {
        std::cerr << "exception: " << e.what() << "\n";
        return 1;
    }
    while (*++argv)
        std::cout << *argv << ":\n-> " << _(*argv) << "\n";
    return 0;
}
