/*
 *  TEST: GCommand
 *
 *  This takes a number of PHost CP commands and dissects these into
 *  their internal representation.
 */
#include <iostream>
#include "game/cmds.h"

int main(int argc, char** argv)
{
    while (*++argv) {
        string_t cmd = *argv;
        std::cout << "`" << cmd << "':\n";
        if (GCommand::isMessageIntroducer(cmd))
            std::cout << "\tis message introducer\n";
        if (GCommand* c = GCommand::parseCommand(cmd, true)) {
            std::cout << "\tis valid command:\n"
                      << "\t. type: " << int(c->getCommand()) << "\n"
                      << "\t. id  : " << c->getId() << "\n"
                      << "\t. arg : `" << c->getArg() << "'\n";
            std::cout << "\tcanonical form: `" << c->getCommandText() << "'\n";
            delete c;
        }
    }
}
