/*
 *  TEST: GfxXorFilter, GfxOffset
 *
 *  This draws a simple test graphics to exercise XOR drawing.
 *  It then draws the figure again to test the cooperation of
 *  GfxXorFilter and GfxOffset.
 */

#include <SDL/SDL.h>
#include "gfx/gfx.h"
#include "gfx/palette.h"
#include "gfx/clip.h"

void thing(Ptr<GfxCanvas> s)
{
    s->drawBar(GfxRect(100, 100, 300, 300), 15, 0, SOLID_FILL, SDL_ALPHA_OPAQUE);

    Ptr<GfxCanvas> x = new GfxXorFilter(s);
    for (int i = 0; i < 16; ++i)
        x->drawHLine(0, 120 + 5*i, 500, i, 255U, SDL_ALPHA_OPAQUE);
    x->update(GfxRect(0, 0, 640, 480));

    SDL_Event e;
    while (SDL_WaitEvent(&e) && e.type != SDL_KEYDOWN)
        ;
}

int main()
{
    if (SDL_Init(SDL_INIT_VIDEO) != 0) {
        printf("error initializing SDL: %s\n", SDL_GetError());
        return 1;
    }
    atexit(SDL_Quit);

    SDL_Surface* sfc = SDL_SetVideoMode(640, 480, 16, SDL_HWPALETTE);
    if (!sfc) {
        printf("can't set video mode\n");
        return 1;
    }

//     initPalette(sfc);

    Ptr<GfxCanvas> s = new GfxSurface(sfc, false);
    thing(s);

    s->drawBar(GfxRect(0, 0, 640, 480), 0, 0, SOLID_FILL, SDL_ALPHA_OPAQUE);
    s = new GfxOffset(10, 10, s);
    thing(s);
}
