/**
  *  \file ui/peerlink.h
  */
#ifndef PCC_V2_UI_PEERLINK_H
#define PCC_V2_UI_PEERLINK_H

#include "cpluslib/sigslot.h"
#include "cpluslib/object.h"

class UIPeer : public Object {
    Signal0 sig_death;
    friend class UIBasicPeerLink;
 public:
    UIPeer();
    ~UIPeer();
};

class UIBasicPeerLink {
    void*   cookie;
    UIPeer* peer;
    void    onPeerDeath();
 public:
    UIBasicPeerLink(UIPeer* peer);
    ~UIBasicPeerLink();
    UIPeer* get() const { return peer; }
    void    set(UIPeer* p);
};

template<class T>
class UIPeerLink : private UIBasicPeerLink {
 public:
    UIPeerLink(T* p = 0) : UIBasicPeerLink(p) { }
    T*    get() const { return static_cast<T*>(UIBasicPeerLink::get()); }
    void  set(T* p)   { UIBasicPeerLink::set(p); }
};

#endif
