/**
  *  \file ui/util.h
  *
  *  (c) 2001,2002,2003 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_UI_UTIL_H
#define PCC_V2_UI_UTIL_H

#include "gfx/gfx.h"
#include "gfx/pixmap.h"
#include "gfx/font.h"

enum TFrameColor {
    cf_None,
    cf_Green,
    cf_Red,
    cf_Yellow,
    cf_Gray
};

void drawTiledArea(GfxCanvas* can, GfxRect r, Ptr<GfxPixmap> pix,
                   uint32 color, int alter);
void drawFrameUp(GfxCanvas* can, GfxRect r);
void drawFrameDown(GfxCanvas* can, GfxRect r);
void drawColorFrame(GfxCanvas* can, GfxRect r, TFrameColor fc, bool update=true);

int countLines(GfxFont* font, int width, string_t s);
void outTextFormatted(GfxCanvas* can, GfxParameters& parm, GfxFont* font,
                      int x, int y, int width, string_t s);

#endif
