/**
  *  \file util/atom.h
  *
  *  (c) 2001,2002,2003 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_UTIL_ATOM_H
#define PCC_V2_UTIL_ATOM_H

#include <cstddef>

#include "cpluslib/string.h"

enum {
    ATOM_LOWER_BOUND = 20000,
    NULL_ATOM        = 0
};

typedef unsigned int atom_t;

/* Atom table */
atom_t   atom(const char* str);
atom_t   atom(const string_t& str);
string_t atomStr(atom_t atom);
atom_t   atomNC(const char* str);
atom_t   atomNC(const string_t& str);

bool isAtom(atom_t);

/* Hashing */
unsigned int strHash(const char* str, std::size_t length);
unsigned int strHash(const char* str);
inline unsigned int strHash(const string_t& str) { return strHash(str.data(), str.length()); }

#endif
