/**
  *  \file compat.h
  *  \brief C++ Compatibility Hacks
  *
  *  (c) 2001,2002,2003 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_COMPAT_H
#define PCC_V2_COMPAT_H

#include "defs.h"

/* Make stream traits work */
#ifdef HAVE_STREAM_TRAITS
#  define STREAM_CHAR_TRAITS std::streambuf::traits
#else
struct stream_char_traits {
    static int eof() { return -1 /* EOF, actually */; }
    static int to_int_type(char c) { return (unsigned char) c; }
    static char narrow(int i) { return i; }
};
#  define STREAM_CHAR_TRAITS stream_char_traits
#endif

#endif
