/**
  *  \file util/conf-glob.cc
  *  \brief Global Configuration File
  *
  *  This module contains the global configuration file instance.
  *
  *  (c) 2001,2002,2003 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */

#include "util/confpars.h"
#include "arch/platform.h"
#include "fileio/dirs.h"

ConfigFile config_file;

static string_t
getConfigFileName()
{
    return Directory::makeFileName(Platform::getUserSettingsDirectory(), "pcc2.ini");
}

void
loadConfig()
{
    config_file.load(getConfigFileName());
}

void
saveConfig()
{
    config_file.save(getConfigFileName());
}
